--[[
ToDo:
    - 
]]

local UPDATEPERIOD, elapsed = 0.5, 0
local L = LibStub("AceLocale-3.0"):GetLocale("SimpleILevel", true);
	L.alts = {
		addonName = "Simple iLevel - Alts",
		desc = "View iLvL of your alts",
		load = "Alts Module Loaded",
		name = "SiL Alts",
		nameShort = "Alts",
		options = {
			chatEvents = "Show Characters:",
			showAllRealms = "Show All Realms",
			showAllRealmsDesc = "Show characters on all realms or just this one.",
			showAllFactions = "Show All Factions",
			showAllFactionsDesc = "Show characters from all factions or just your current one.",
			onlyMaxLevel = "Show Only Max Level",
			onlyMaxLevelDesc = "Check to hide any characters below the max level.",
			colorizeILvl = "Use SiL colorized ilvl",
			colorizeILvlDesc = "Check this box to colorize the ilvl based on its score. Uncheck to use default class colors.",
			enabled = "Enabled",
			enabledDesc = "Enable all features or SiL Social.",
			name = "SiL Alts Options",
			realmList = "Show All Realms",
		},
	}

SIL_Alt = LibStub("AceAddon-3.0"):NewAddon('SIL_Alt', "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0");

SIL_Alt.action = {};        -- DB of unitGUID->function to run when a update comes through
SIL_Alt.hooks = {};         -- List of hooks in [type][] = function;
SIL_Alt.autoscan = 0;       -- time() value of last autoscan, must be more then 1sec
SIL_Alt.lastScan = {};      -- target = time();
SIL_Alt.grayScore = 7;      -- Number of items to consider gray/aprox
SIL_Alt.ldbAuto = false;    -- AceTimer for LDB
SIL_Alt.playerNames = {};

local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
local LibQTip = LibStub:GetLibrary("LibQTip-1.0");
SIL_Alt.callback = LibStub("CallbackHandler-1.0"):New(SIL_Alt);


-- Setup Display Fonts
-- Hunter
hunterFont = CreateFont("hunterFont")
hunterFont:SetFont(GameTooltipText:GetFont(), 10)
hunterFont:SetTextColor(RAID_CLASS_COLORS["HUNTER"].r,RAID_CLASS_COLORS["HUNTER"].g,RAID_CLASS_COLORS["HUNTER"].b)
 
-- Warlock
warlockFont = CreateFont("warlockFont")
warlockFont:SetFont(GameTooltipText:GetFont(), 10)
warlockFont:SetTextColor(RAID_CLASS_COLORS["WARLOCK"].r,RAID_CLASS_COLORS["WARLOCK"].g,RAID_CLASS_COLORS["WARLOCK"].b)
 
-- Priest
priestFont = CreateFont("priestFont")
priestFont:SetFont(GameTooltipText:GetFont(), 10)
priestFont:SetTextColor(RAID_CLASS_COLORS["PRIEST"].r,RAID_CLASS_COLORS["PRIEST"].g,RAID_CLASS_COLORS["PRIEST"].b)
 
-- Mage
mageFont = CreateFont("mageFont")
mageFont:SetFont(GameTooltipText:GetFont(), 10)
mageFont:SetTextColor(RAID_CLASS_COLORS["MAGE"].r,RAID_CLASS_COLORS["MAGE"].g,RAID_CLASS_COLORS["MAGE"].b)
 
-- Paladin
paladinFont = CreateFont("paladinFont")
paladinFont:SetFont(GameTooltipText:GetFont(), 10)
paladinFont:SetTextColor(RAID_CLASS_COLORS["PALADIN"].r,RAID_CLASS_COLORS["PALADIN"].g,RAID_CLASS_COLORS["PALADIN"].b)
 
-- Shaman
shamanFont = CreateFont("shamanFont")
shamanFont:SetFont(GameTooltipText:GetFont(), 10)
shamanFont:SetTextColor(RAID_CLASS_COLORS["SHAMAN"].r,RAID_CLASS_COLORS["SHAMAN"].g,RAID_CLASS_COLORS["SHAMAN"].b)
 
-- Druid
druidFont = CreateFont("druidFont")
druidFont:SetFont(GameTooltipText:GetFont(), 10)
druidFont:SetTextColor(RAID_CLASS_COLORS["DRUID"].r,RAID_CLASS_COLORS["DRUID"].g,RAID_CLASS_COLORS["DRUID"].b)
 
-- deathknight
deathknightFont = CreateFont("deathknightFont") 
deathknightFont:SetFont(GameTooltipText:GetFont(), 10)
deathknightFont:SetTextColor(RAID_CLASS_COLORS["DEATHKNIGHT"].r,RAID_CLASS_COLORS["DEATHKNIGHT"].g,RAID_CLASS_COLORS["DEATHKNIGHT"].b)
 
-- Rogue
rogueFont = CreateFont("rogueFont")
rogueFont:SetFont(GameTooltipText:GetFont(), 10)
rogueFont:SetTextColor(RAID_CLASS_COLORS["ROGUE"].r,RAID_CLASS_COLORS["ROGUE"].g,RAID_CLASS_COLORS["ROGUE"].b)
 
-- Warrior
warriorFont = CreateFont("warriorFont")
warriorFont:SetFont(GameTooltipText:GetFont(), 10)
warriorFont:SetTextColor(RAID_CLASS_COLORS["WARRIOR"].r,RAID_CLASS_COLORS["WARRIOR"].g,RAID_CLASS_COLORS["WARRIOR"].b)

-- Monk
monkFont = CreateFont("monkFont")
monkFont:SetFont(GameTooltipText:GetFont(), 10)
monkFont:SetTextColor(RAID_CLASS_COLORS["MONK"].r,RAID_CLASS_COLORS["MONK"].g,RAID_CLASS_COLORS["MONK"].b)
 
CLASS_FONTS = {
    ["HUNTER"] = hunterFont,
    ["WARLOCK"] = warlockFont,
    ["PRIEST"] = priestFont,
    ["PALADIN"] = paladinFont,
    ["MAGE"] = mageFont,
    ["ROGUE"] = rogueFont,
    ["DRUID"] = druidFont,
    ["SHAMAN"] = shamanFont,
    ["WARRIOR"] = warriorFont,
    ["DEATHKNIGHT"] = deathknightFont,
    ["MONK"] = monkFont,
};



function SIL_Alt:OnInitialize()

	self.sort_table = {}
    self.scanqueue = {}
    self.partyName = {}
    self.partyClass = {}
    self.partyLevel = {}
    self.partyiLvl = {}
    
    self.faction = UnitFactionGroup("player")
    self.realm = GetRealmName()
    self.pc = UnitName("player")
     
    SIL:Print(L.alts.load, GetAddOnMetadata("SimpleILevel_Alts", "Version"));
    
    self.db = LibStub("AceDB-3.0"):New("SIL_Alts", SILAlt_Defaults, true);
    SIL.aceConfig:RegisterOptionsTable(L.alts.nameShort, SILAlt_Options, {"sia", "silalt", "simpleilevelalts"});
    SIL.aceConfigDialog:AddToBlizOptions(L.alts.nameShort, "Alts", L.core.name);
    dataobj = ldb:GetDataObjectByName(L.core.name);
    
	
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED", function() SIL_Alt:StartScore('player'); end);
    self:RegisterEvent("PLAYER_ENTERING_WORLD", function() SIL_Alt:UpdateLDB(); end);
    self:RegisterEvent("PLAYER_ENTERING_WORLD", function() SIL_Alt:StartScore('player'); end);
    
	
	SIL_Alt:StartScore('player');
	SIL_Alt:UpdateLDB();
	self:SetupSILMenu();
   

	function dataobj:OnEnter()
		
     	-- Acquire a tooltip with 3 columns, respectively aligned to left, center and right
     	local tooltip = LibQTip:Acquire("SimpleiLevel", 3, "LEFT", "CENTER", "RIGHT")
     	self.tooltip = tooltip
 
	    tooltip:Clear()
 
     	-- New font looking like GameTooltipText but White with height 12
     	local white10Font = CreateFont("white10Font")
     	white10Font:SetFont(GameTooltipText:GetFont(), 10)
     	white10Font:SetTextColor(1,1,1)
 
	     -- New font looking like White15font but with height 14
    	local white14Font = CreateFont("white14Font")
     	white14Font:CopyFontObject(white10Font)
     	white14Font:SetFont(white14Font:GetFont(), 14)
 
	    local hordeFont = CreateFont("hordeFont")
     	hordeFont:CopyFontObject(white10Font)
     	hordeFont:SetTextColor(1,0,0)
     	hordeFont:SetFont(hordeFont:GetFont(), 14)
 
	    local allianceFont = CreateFont("allianceFont")
    	allianceFont:CopyFontObject(white10Font)
     	allianceFont:SetTextColor(0,0,1)
     	allianceFont:SetFont(allianceFont:GetFont(), 14)
 
     	-- New font looking like GameTooltipText but White with height 15
     	local green12Font = CreateFont("green12Font")
     	green12Font:SetFont(GameTooltipText:GetFont(), 12)
     	green12Font:SetTextColor(0,1,0)
 
 
 
     	tooltip:SetFont(white10Font)
     	tooltip:SetHeaderFont(white14Font)
     	-- Add an header filling only the first two columns
     	local line, column = tooltip:AddHeader()
     	tooltip:SetCell(line, 1, "Character iLevel Breakdown", "CENTER", 3)
     	names = {}
     	tooltip:AddSeparator()
 
     	--[[
     	for name in pairs (SIL_Alt.db.global.alts) do
     		if SIL_Alt.db.global.alts[name].show then
        		local line, column = tooltip:AddLine()
                   	tooltip:SetCell(line, 1, SIL_Alt.db.global.alts[name].name, CLASS_FONTS[SIL_Alt.db.global.alts[name].class])
                   	if SIL_Alt.db.global.options.colorizeILvl then
                   		local score = SIL_Alt.db.global.alts[name].score
                   		local items = SIL_Alt.db.global.alts[name].items
                   		text = SIL:FormatScore(score, items, true);
                   		tooltip:SetCell(line, 3, text)
                   	else
                    	tooltip:SetCell(line, 3, string.format("%.1f",SIL_Alt.db.global.alts[name].score), CLASS_FONTS[SIL_Alt.db.global.alts[name].class])
                    end
                    tooltip:SetCell(line, 2, SIL_Alt.db.global.alts[name].level, CLASS_FONTS[SIL_Alt.db.global.alts[name].class])
 			else
 
 			end
     	end
     	]]
     	
     	for faction, faction_table in pairs (SIL_Alt.db.global.alts) do
          if SIL_Alt.db.global.options.showAllFactions or faction == SIL_Alt.faction  then
               if faction ~= "partyData" then
                    if faction == "Horde" then
                         tooltip:SetHeaderFont(hordeFont)
                    else
                         tooltip:SetHeaderFont(allianceFont)
                    end
                    if SIL_Alt.db.global.options.showAllFactions then
	                    tooltip:AddHeader(faction)
	                end
                    for realm, realm_table in pairs (faction_table) do
                         if SIL_Alt.db.global.options.showAllRealms or realm == SIL_Alt.realm then
                              tooltip:SetHeaderFont(green12Font)
                              if SIL_Alt.db.global.options.showAllRealms then
	                              tooltip:AddHeader(realm)
	                          end
                              SIL_Alt:FetchOrderedNames(names, realm_table)
                              for _,name in ipairs (names) do
                              	   userver = " - " .. realm;
                                   if not SIL_Alt.db.global.ignore[name .. userver].show == false then
                                   		if SIL_Alt.db.global.options.onlyMaxLevel and SIL_Alt.db.global.alts[faction][realm][name].level == 90 then
                                        	local line, column = tooltip:AddLine()
                                     		tooltip:SetCell(line, 1, SIL_Alt.db.global.alts[faction][realm][name].name, CLASS_FONTS[SIL_Alt.db.global.alts[faction][realm][name].class])
                   							if SIL_Alt.db.global.options.colorizeILvl then
                   								local score = SIL_Alt.db.global.alts[faction][realm][name].score
                   								local items = SIL_Alt.db.global.alts[faction][realm][name].items
                   								text = SIL:FormatScore(score, items, true);
                   								tooltip:SetCell(line, 3, text)
                   							else
                    							tooltip:SetCell(line, 3, string.format("%.1f",SIL_Alt.db.global.alts[faction][realm][name].score), CLASS_FONTS[SIL_Alt.db.global.alts[faction][realm][name].class])
                    						end
                    						if not SIL_Alt.db.global.options.onlyMaxLevel then
                    							tooltip:SetCell(line, 2, SIL_Alt.db.global.alts[faction][realm][name].level, CLASS_FONTS[SIL_Alt.db.global.alts[faction][realm][name].class]) 
                    						end
                    					elseif not SIL_Alt.db.global.options.onlyMaxLevel then
                    						local line, column = tooltip:AddLine()
                                     		tooltip:SetCell(line, 1, SIL_Alt.db.global.alts[faction][realm][name].name, CLASS_FONTS[SIL_Alt.db.global.alts[faction][realm][name].class])
                   							if SIL_Alt.db.global.options.colorizeILvl then
                   								local score = SIL_Alt.db.global.alts[faction][realm][name].score
                   								local items = SIL_Alt.db.global.alts[faction][realm][name].items
                   								text = SIL:FormatScore(score, items, true);
                   								tooltip:SetCell(line, 3, text)
                   							else
                    							tooltip:SetCell(line, 3, string.format("%.1f",SIL_Alt.db.global.alts[faction][realm][name].score), CLASS_FONTS[SIL_Alt.db.global.alts[faction][realm][name].class])
                    						end
                    						if not SIL_Alt.db.global.options.onlyMaxLevel then
	                    						tooltip:SetCell(line, 2, SIL_Alt.db.global.alts[faction][realm][name].level, CLASS_FONTS[SIL_Alt.db.global.alts[faction][realm][name].class])
	                    					end
                    					end
                                   end
                              end
                         end
                    end
                    tooltip:AddLine(" ")
               end
          end
     end
     	
     	
     	tooltip:AddLine(L.core.minimapClick);
        tooltip:AddLine(L.core.minimapClickDrag);
	    -- Use smart anchoring code to anchor the tooltip to our frame
    	tooltip:SmartAnchorTo(self)
 
     	-- Show it, et voil‡ !
     	tooltip:Show()
	end
 
 
 
	function dataobj:OnLeave()
 
   		-- Release the tooltip
   		LibQTip:Release(self.tooltip)
   		self.tooltip = nil
	end
	
end

function SIL_Alt:StartScore(target, callback)
    if InCombatLockdown() or not CanInspect(target) then 
        if callback then callback(false, target); end
        return false;
    end
    
    self.autoscan = time();
    local guid = SIL_Alt:AddPlayer(target);
    
    if not self.lastScan[target] or self.lastScan[target] ~= time() then
        if guid then
            self.action[guid] = callback;
            self.lastScan[target] = time();
            
            local canInspect = self.inspect:RequestItems(target, true);
            
            if not canInspect and callback then
                callback(false, target);
            else
                return true;
            end
        end
    end
    
    if callback then callback(false, target); end
    return false;
end

function SIL_Alt:AddPlayer(target)
	local guid = UnitGUID("player");
    
    if guid then
        local name, realm = UnitName("player");
        local className, class = UnitClass("player");
        local level = UnitLevel("player");
        local faction = UnitFactionGroup("player")

        
        if not realm then
            realm = GetRealmName();
        end
        
        if name and realm and class and level then
            
            -- Start a table for them
            if not SIL_Alt.db.global.alts[faction][realm][name] then
                SIL_Alt.db.global.alts[faction][realm][name] = {};
            end
            
            SIL_Alt.db.global.alts[faction][realm][name].guid = guid;
            SIL_Alt.db.global.alts[faction][realm][name].name = name;
            SIL_Alt.db.global.alts[faction][realm][name].realm = realm;
            SIL_Alt.db.global.alts[faction][realm][name].class = class;
            SIL_Alt.db.global.alts[faction][realm][name].level = level;
            SIL_Alt.db.global.alts[faction][realm][name].target = target;
            
            if not SIL_Alt.db.global.alts[faction][realm][name].show then
	            SIL_Alt.db.global.alts[faction][realm][name].show = true;
	        end
            
            local score, age, items = SIL:GetScoreGUID(guid)
            
            SIL_Alt.db.global.alts[faction][realm][name].score = score;
            SIL_Alt.db.global.alts[faction][realm][name].items = items;
            SIL_Alt.db.global.alts[faction][realm][name].time = age;
        end
	end
end

function SIL_Alt:UpdateLDB(force, auto)
    
	local label = UnitName('player');
	        
        local text = 'n/a';
    	if UnitGUID('player') then
        	local score, age, items = SIL:GetScoreTarget('player');
            text = SIL:FormatScore(score, items, true);
        end
        
		SIL_Alt:UpdateLDBText(label, text)

end

function SIL_Alt:UpdateLDBText(label, text)
    
    
    -- Add the label
        
    local ldbtext = text;
    local ldbUpdated = time();
    local ldbLable = label;
end


function SIL_Alt:FetchOrderedNames(names, characters)
    wipe(names)
    for name, name_table in pairs(characters) do
        table.insert(names, name)
    end
    SIL_Alt.sort_table = characters
        
        table.sort(names, revilvlSort)

end

function revilvlSort(a,b)
  return SIL_Alt.sort_table[b].score < SIL_Alt.sort_table[a].score end
 


--[[
    Setters, Getters and Togglers
]]
function SIL_Alt:SetShowAllRealms(v) self.db.global.options.showAllRealms = v; end
function SIL_Alt:SetShowAllFactions(v) self.db.global.options.showAllFactions = v; end
function SIL_Alt:SetOnlyMaxLevel(v) self.db.global.options.onlyMaxLevel = v; end
function SIL_Alt:SetColorizeILvl(v) self.db.global.options.colorizeILvl = v; end

function SIL_Alt:GetShowAllRealms() return self.db.global.options.showAllRealms; end
function SIL_Alt:GetShowAllFactions() return self.db.global.options.showAllFactions; end
function SIL_Alt:GetOnlyMaxLevel() return self.db.global.options.onlyMaxLevel; end
function SIL_Alt:GetColorizeILvl() return self.db.global.options.colorizeILvl; end
function SIL_Alt:GetChatEvent(e) return self.db.global.ignore[e].show; end

function SIL_Alt:ToggleShowAllRealms() self:SetShowAllRealms(not self:GetShowAllRealms()); end
function SIL_Alt:ToggleShowAllFactions() self:SetShowAllFactions(not self:GetShowAllFactions()); end
function SIL_Alt:ToggleOnlyMaxLevel() self:SetOnlyMaxLevel(not self:GetOnlyMaxLevel()); end
function SIL_Alt:ToggleColorizeILvl() self:SetColorizeILvl(not self:GetColorizeILvl()); end
function SIL_Alt:ToggleChatEvent(e) self:SetChatEvent(e, not self:GetChatEvent(e)); end

-- More advanced ones
function SIL_Alt:SetChatEvent(e, v) 
    self.db.global.ignore[e].show = v; 
end

function SIL_Alt:GetPlayerNames()
	for pfaction, pfaction_table in pairs(self.db.global.alts) do
		for prealm, prealm_table in pairs(pfaction_table) do
			for pname in pairs(prealm_table) do
				pserver = " - " .. prealm;
				SIL_Alt.playerNames[pname .. pserver] = pname .. pserver;
			end
		end
	end
	return SIL_Alt.playerNames;
end

-- Add SiL Menu Options
function SIL_Alt:SetupSILMenu()
    
    SIL:AddMenuItems('middle', {
        text = L.alts.options.name,
        isTitle = 1,
        notCheckable = 1,
    }, 1);
    
    SIL:AddMenuItems('middle', {    
        text = 'Show Max Level Only',
        func = function() SIL_Alt:ToggleOnlyMaxLevel(); end,
        checked = function() return SIL_Alt:GetOnlyMaxLevel(); end,
    }, 1);
    
    SIL:AddMenuItems('middle', {    
        text = 'Show All Realms',
        func = function() SIL_Alt:ToggleShowAllRealms(); end,
        checked = function() return SIL_Alt:GetShowAllRealms(); end,
    }, 1);
    
    SIL:AddMenuItems('middle', {    
        text = 'Show All Factions',
        func = function() SIL_Alt:ToggleShowAllFactions(); end,
        checked = function() return SIL_Alt:GetShowAllFactions(); end,
    }, 1);
    
    SIL:AddMenuItems('middle', {
    	text = 'Colorize ilvl',
    	func = function() SIL_Alt:ToggleColorizeILvl(); end,
    	checked = function() return SIL_Alt:GetColorizeILvl(); end,
    }, 1);
end

-- Options displayed in Blizz Interface options pane
SILAlt_Options = {
	name = L.alts.options.name,
	type = "group",
	args = {
        colorizeILvl = {
            name = L.alts.options.colorizeILvl,
            desc = L.alts.options.colorizeILvlDesc,
            type = "toggle",
            set = function(i,v) SIL_Alt:SetColorizeILvl(v); end,
            get = function(i) return SIL_Alt:GetColorizeILvl(); end,
            order = 5,
        },
        
        showAllRealms = {
        	name = L.alts.options.showAllRealms,
        	desc = L.alts.options.showAllRealmsDesc,
        	type = "toggle",
        	set = function(i,v) SIL_Alt:SetShowAllRealms(v); end,
        	get = function(i) return SIL_Alt:GetShowAllRealms(); end,
        	order = 6,
        },
        showAllFactions = {
        	name = L.alts.options.showAllFactions,
        	desc = L.alts.options.showAllFactionsDesc,
        	type = "toggle",
        	set = function(i,v) SIL_Alt:SetShowAllFactions(v); end,
        	get = function(i) return SIL_Alt:GetShowAllFactions(); end,
        	order = 7,
        },
        onlyMaxLevel = {
        	name = L.alts.options.onlyMaxLevel,
        	desc = L.alts.options.onlyMaxLevelDesc,
        	type = "toggle",
        	set = function(i,v) SIL_Alt:SetOnlyMaxLevel(v); end,
        	get = function(i) return SIL_Alt:GetOnlyMaxLevel(); end,
        	order = 8,
        },
        playerNames = {
            name = L.alts.options.chatEvents,
            type = 'multiselect', 
            values = function() return SIL_Alt:GetPlayerNames(); end;
            get = function(s,e) return SIL_Alt:GetChatEvent(e) end;
            set = function(s,e,v) return SIL_Alt:SetChatEvent(e, v) end;
            order = 100,
        },
        
	}
}


-- Default SV Table
SILAlt_Defaults = {
	global = {
		options = {
			color = true,
			showAllRealms = true,
			colorizeILvl = true,
			showAllFactions = true,
			onlyMaxLevel = true,
		},
		alts = {
			-- Faction
           	['*'] = {
               	-- Realm
        	    ['*'] = {
            	  	-- Name
                    ['*'] = {
                	   	class = "",   -- Non Localised class name
                        level = 0,
                        score = 0,
                        time = 0,
                    }
                }
            }
		},
		ignore = {
			['*'] = {
				show = "",
			}
		},
	}
};